<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Asignacion Masiva de Supervisiones</strong>
    </div>

    <div class="cotm">
      <div class="tmod">
        <strong>Carga Masiva de Supervisiones a Sucursales</strong>
        <!--<div class="supSec"><strong>Trimestre: {{getTrimestres()}} / Año: {{anio.getFullYear()}}</strong></div>  -->
        <div class="supSec">
          <strong>{{ anio.getFullYear() }}</strong>
        </div>
      </div>
    </div>

    <!-- drag and drop -->
    <v-container fluid>
      <div class="contSecc " @dragover.prevent @drop.prevent>
        <div class="gris" @drop="handleFileDrop" v-show="panDragDrop">
          <div style="background:#fafafa">
            <div class="contModal cmodal">
              <div class="amodal tCenter">
                <div
                  class="myDropProtocolos dropzone dz-clickable dz-verfolow rayado"
                  v-cloak
                  @drop.stop.prevent="readFile"
                  @dragover.prevent
                >
                  <div class="dz-default dz-message" data-dz-message>
                    <div class="padding">
                      <img
                        src="@/assets/img/cloud-computing.svg"
                        style="height:80px;width:90px;"
                        alt
                      />
                    </div>
                    <div>
                      <strong>
                        <b class="name-file">{{ file.name_file }}</b>
                      </strong>
                      <br />
                      <br />
                      <b>
                        Paso 1. Suelta aquí el layout de Supervisiones para
                        subir tu información.
                        <div
                          class="btnCenter file-select file-wrapper padding "
                        >
                          <v-btn color="primary" dark>
                            <strong style="fond-size : 16px; color:  #000;"
                              >Seleccionar Archivo
                              <input
                                type="file"
                                accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
                                @change="readFile"
                              />
                            </strong>
                          </v-btn>
                          <v-btn
                            color="primary"
                            dark
                            class="ml-5"
                            @click="valorTab = true"
                          >
                            <strong style="fond-size : 16px; color:  #000;"
                              >Cargar Datos</strong
                            >
                          </v-btn>

                          <v-btn
                            color="primary"
                            dark
                            class="ml-5"
                            @click="test"
                          >
                            <strong
                              style="fond-size : 16px; color:  #000;"
                            ></strong>
                          </v-btn>
                        </div>
                      </b>
                      <h6>
                        <label
                          >No cuentas con el layout
                          <a
                            href="http://10.53.33.82/franquicia/Layout_Asignacion.xlsx"
                            class="dz-clickable"
                            >Descargalo aqui</a
                          >
                        </label>
                      </h6>
                    </div>
                  </div>
                  <br />
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </v-container>

    <!-- tabla y encabezado tabla -->
    <div class="contSecc">
      <hr
        role="separator"
        aria-orientation="horizontal"
        class="v-divider theme--light"
      />
      <div class="contSecc">
        <div class="titSec" v-if="valorTab">
          <h2>
            Paso 2. Visualiza, verifica y corrige, si es necesario, tus
            supervisiones
          </h2>
        </div>
      </div>

      <div class="divBuscador" v-if="valorTab">
        <div>
          <v-text-field
            v-model="search"
            class="buscador"
            append-icon="mdi-magnify"
            label="Buscar..."
            single-line
            hide-details
            clearable
          >
          </v-text-field>
        </div>
      </div>

      <v-data-table
        v-if="valorTab"
        :headers="encabezadoAsignacion"
        :items="supervs"
        :page.sync="page"
        :items-per-page="itemsPerPage"
        @page-count="pageCount = $event"
        append-icon="search"
        ref="tabla"
        :search="search"
        class="tblGeneral tblAsignacionPrevia"
      >
        <template v-slot:item.Eliminar="{ item }">
          <!-- <button @click="dialogElimina=true, this.itemSeleccionado=item, asignacionEliminar=item"> -->
          <button @click="setItemDeleting({ item }), (dialogElimina = true)">
            <strong style="fond-size : 16px;">Eliminar</strong>
          </button>
        </template>
      </v-data-table>

      <div>
        <div class="btnCenter" v-if="valorTab">
          <v-btn
            color="primary"
            dark
            @click="
              setNegociosHardcode();
              dialogAsignacion = true;
            "
          >
            <strong style="fond-size : 16px; color:#000;"
              >Añadir Supervisión</strong
            >
          </v-btn>
        </div>
      </div>
    </div>
    <!-- fin container-->

    <div class="contSecc">
      <div class="titSec" v-if="valorTab">
        <h2>Último Paso: ¿Toda tu información es correcta?</h2>
      </div>
    </div>
    <div>
      <div class="btnCenter" v-if="valorTab">
        <v-btn
          color="grey"
          dark
          @click="
            dialogAsignacion = false;
            limpiaFormulario();
          "
          class="mr-5"
        >
          <strong style="fond-size :16px; color: #000;">No, Cancelar</strong>
        </v-btn>
        <v-btn color="primary" dark @click="srvCargaSupervisiones()">
          <strong style="fond-size : 16px; color:#000;"
            >Si, guardar supervisiones</strong
          >
        </v-btn>
      </div>
    </div>

    <!-- Dialog Elimina -->
    <v-dialog v-model="dialogElimina" max-width="800" persistent>
      <v-card class="padding">
        <v-card-title class="headline">
          <div class="titModal">
            <div>
              <strong
                >Eliminar Supervision a CECO:
                {{ this.itemSeleccionado.Economico }}</strong
              >
            </div>
          </div>
        </v-card-title>
        <div class="contModal tCenter">
          <div>
            <strong>Supervisor: {{ this.itemSeleccionado.idUsuario }}</strong>
            <br />
            <strong
              >Coordinador: {{ this.itemSeleccionado.usuarioAsigna }}</strong
            >
            <br />
            <strong>Fecha: {{ this.itemSeleccionado.fecha }} </strong> <br />
          </div>
          <div></div>
        </div>

        <div class="btnCenter">
          <v-btn color="grey" dark @click="dialogElimina = false" class="mr-10">
            <strong style="fond-size : 16px; ">No, Conservar visita</strong>
          </v-btn>

          <!-- <v-btn color="primary" dark class="" @click="(dialogConfimacion = true), (dialogElimina = false), eliminaAsignacionPrevia()"> -->
          <!-- <v-btn color="primary" dark class="" @click="test()"> -->
          <v-btn
            color="primary"
            dark
            class=""
            @click="(dialogElimina = false), removeSupervision()"
          >
            <strong style="fond-size : 16px; color:  #000;"
              >Si, eliminar visita</strong
            >
          </v-btn>
        </div>
      </v-card>
    </v-dialog>

    <!-- Dialog dialogAsignacion -->
    <v-dialog v-model="dialogAsignacion" persistent max-width="600px">
      <v-card>
        <div class="gris">
          <v-card-title class="headline">
            <div class="titModal">
              <div><strong>Ingrese Datos para Agregar Supervisión</strong></div>
            </div>
          </v-card-title>

          <div class="divCol spaceCol">
            <div class="col12">
              <strong>Seleccione Fecha:</strong>
              <v-date-picker
                mode="date"
                v-model="addDate"
                @input="menuInicio = false"
                header-color="#ffc900"
                color="#ffeeb2"
              >
              </v-date-picker>
            </div>
          </div>

          <div class="divCol spaceCol">
            <div class="col12">
              <strong>Supervisor a asignar:</strong>
              <br />
              <div class="pRelative">
                <v-autocomplete
                  ref="autoUsuario"
                  v-model="usuarioEncontrado"
                  :items="metadata.usuarios"
                  clearable
                  append-icon
                  item-value="idUsuario"
                  item-text="nombreUsuario"
                  placeholder="Buscar Supervisor"
                  :search-input.sync="textoUsuarioIngresado"
                  :rules="[
                    !!usuarioEncontrado || 'Debes Seleccionar un Supervisor',
                  ]"
                  :cache-items="false"
                  @keyup="actualizaUsuarios"
                  return-object
                ></v-autocomplete>
              </div>
            </div>
          </div>

          <div class="divCol spaceCol">
            <div class="col12">
              <strong>Seleccione ceco:</strong>
              <br />
              <div class="pRelative">
                <v-autocomplete
                  ref="autoCeco"
                  v-model="cecoSeleccionado"
                  :items="metadata.cecos"
                  item-value="ceco"
                  item-text="ceco"
                  clearable
                  dense
                  hide-no-data
                  append-icon
                  :disabled="habilitaSuc"
                  placeholder="Buscar Ceco"
                  :cache-items="false"
                  :search-input.sync="textoIngresado"
                  :rules="[
                    () => !!cecoSeleccionado || 'Debes seleccionar un ceco',
                  ]"
                  @keyup="actualizaCecos()"
                  return-object
                ></v-autocomplete>
                <input type="submit" class="buscar" value @click="getCecos()" />
              </div>
            </div>
          </div>

          <!-- Coordinador -->
          <div class="divCol spaceCol">
            <div class="col12">
              <strong>Coordinador:</strong>
              <br />
              <div class="pRelative">
                <v-autocomplete
                  ref="autoGerente"
                  v-model="gerenteEncontrado"
                  :items="metadata.gerentes"
                  item-value="idUsuario"
                  item-text="nombreUsuario"
                  clearable
                  dense
                  hide-no-data
                  append-icon
                  placeholder="Buscar Coordinador"
                  :cache-items="false"
                  :search-input.sync="textoGerente"
                  :rules="[
                    () =>
                      !!gerenteEncontrado || 'Debe Seleccionar un Coordinador',
                  ]"
                  @keyup="actualizaUsuariosGerentes"
                  return-object
                ></v-autocomplete>
              </div>
            </div>
          </div>

          <!-- Tipo Visita -->
          <div class="divCol spaceCol">
            <div class="col12">
              <strong>Tipo Visita:</strong>
              <br />
              <div class="pRelative">
                <v-autocomplete
                  ref="addTipoVisita"
                  v-model="addTipoVisita"
                  :items="hc_tiposVisita"
                  item-text="tipoVisita"
                  clearable
                  dense
                  hide-no-data
                  append-icon
                  placeholder="Seleccione Tipo de Visita"
                  :cache-items="false"
                  :rules="[
                    () =>
                      !!addTipoVisita || 'Debe Seleccionar un Tipo de Visita',
                  ]"
                  return-object
                ></v-autocomplete>
              </div>
            </div>
          </div>

          <!-- Negocio -->
          <div class="divCol spaceCol">
            <div class="col12">
              <strong>Negocio:</strong>
              <br />
              <div class="pRelative">
                <v-autocomplete
                  ref="addNegocio"
                  v-model="addNegocio"
                  :items="hc_negocios"
                  item-text="negocio"
                  clearable
                  dense
                  hide-no-data
                  append-icon
                  placeholder="Seleccione Negocio"
                  :cache-items="false"
                  :rules="[() => !!addNegocio || 'Debe Seleccionar Negocio']"
                  return-object
                ></v-autocomplete>
              </div>
            </div>
          </div>

          <!-- Tipo Tarea (orden Activos) -->
          <div class="divCol spaceCol">
            <div class="col12">
              <strong
                >Especifique tareas a realizar (separadas por comas):</strong
              >
              <br />
              <div class="pRelative">
                <v-text-field
                  ref="addTipoTarea"
                  hide-details="auto"
                  v-model="addTipoTarea"
                  item-text="addTipoTarea"
                  clearable
                  dense
                  hide-no-data
                  append-icon
                  placeholder="1, 2, 10"
                  return-object
                ></v-text-field>
              </div>
            </div>
          </div>

          <!-- Tickets Relacionados  -->
          <div class="divCol spaceCol">
            <div class="col12">
              <strong>Tickets Relacionados:</strong>
              <br />
              <div class="pRelative">
                <v-text-field
                  ref="addComentTickRelacinados"
                  v-model="addComentTickRelacinados"
                  item-text="addComentTickRelacinados"
                  clearable
                  dense
                  hide-no-data
                  append-icon
                  placeholder="Comentario de los tickets relacionados"
                  :cache-items="false"
                  return-object
                ></v-text-field>
              </div>
            </div>
          </div>

          <div class="btnCenter">
            <v-btn
              color="grey"
              dark
              @click="
                dialogAsignacion = false;
                limpiaFormulario();
              "
              class="mr-10"
            >
              <strong style="fond-size :16px; color: #000;">Cancelar</strong>
            </v-btn>
            <v-btn color="primary" dark @click="tryAddSupervision">
              <!-- <v-btn color="primary" dark @click="this.addSupervision" >-->
              <strong style="fond-size : 16px; color:  #000;">Guardar</strong>
            </v-btn>
          </div>
        </div>
      </v-card>
    </v-dialog>

    <div>
      <h1>.&nbsp;</h1>
    </div>
  </div>
</template>

<script>
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
import Vue from "vue";
import JsonExcel from "vue-json-excel";
import XLSX from "xlsx";

Vue.component("downloadExcel", JsonExcel);

const serviceCommons = store.state.serviceCommons;
export default {
  name: "tabla-visor-asignacion",

  data() {
    return {
      anio: new Date(),
      cards: null,
      breadcrumbs: [
        {
          text: "Asignación de Supervisiones",
          disabled: false,
          exact: true,
          to: {
            name: "supervision_mantenimiento_asignaciones",
          },
        },
        {
          text: "Asignación Manual de Supervisiones",
          disabled: true,
          exact: true,
          to: {
            name: "supervision-mantenimiento_asignacion-manual",
          },
        },
      ],
      file: {
        form_data: null,
        name_file: null,
        content_b64: null,
        content_type: null,
      },
      encabezadoAsignacion: [
        { text: "iden", value: "Iden", align: "center" },
        { text: "Economico", value: "idCeco", align: "center" },
        { text: "Supervisor", value: "idUsuario", align: "center" },
        { text: "Coordinador", value: "usuarioAsigna", align: "center" },
        { text: "Tipo Visita", value: "tipoVisita", align: "center" },
        { text: "Tipo Tarea", value: "ordenActivos", align: "center" },
        { text: "Negocio", value: "negocio", align: "center" },
        {
          text: "Tickets Relacionados",
          value: "comentarioTicketRelacionados",
          align: "center",
        },
        { text: "Fecha dd/mm/aaaa", value: "fecha", align: "center" },
        { text: "Verificación", value: "verif", align: "center" },
        { text: "Acción", value: "Eliminar", align: "center" },
      ],
      infoJson: "",
      supervs: [],
      metadata: {
        cecos: [],
        usuarios: [],
        negocios: [],
        gerentes: [],
      },
      hc_tiposVisita: ["GENERAL", "ESPECIAL", "EMERGENCIA"],
      hc_negocios: ["EKT", "OCC", "DAZ", "ITK", "CDT"],
      addTipoVisita: "",
      addNegocio: "",
      addTipoTarea: "",
      addComentTickRelacinados: "",
      addDate: "",
      //   valores paginado
      pageCount: 1,
      page: 1,
      itemsPerPage: 10,
      search: "",
      //    D I A L O G S
      panDragDrop: true,
      dialogElimina: false,
      dialogAsignacion: false,
      //    O T R O S    E L E M E N T O S
      valorTab: false,
      itemSeleccionado: "",
      xlsOk: false,
      textoUsuarioIngresado: "",
      usuarioEncontrado: "",
      habilitaSuc: true,
      textoIngresado: "",
      cecoSeleccionado: "",
      textoGerente: "",
      gerenteEncontrado: "",
      tipoVisita: "",
      negocioSelecionado: "",
    };
  },

  methods: {
    test(elItem) {
      console.log("TESTING..." + this.getMaxIden());
    },
    tryAddSupervision() {
      console.log("INTENTANDO add 1");
      let _verif = "";
      let _idUsuario = "";
      let _coordi = "";
      let _idCeco = "";
      let _fecha = this.addDate;
      let _fechaProgramada = _fecha;
      let _comentarioTicketRelacionados = this.addComentTickRelacinados;
      let _tipoVisita = this.addTipoVisita;
      let _negocio = this.addNegocio;
      let _tipoTarea = this.addTipoTarea.replace(/\s/g, "");

      if (typeof this.addDate == "undefined") {
        alert("Error en fecha [addDate: " + this.addDate + "]");
        return;
      }

      if (_fecha.length < 2) {
        alert("Sin fecha detectada");
        return;
      }

      let _resFecha = this.ValidaFecha(_fecha, "man");
      console.log("kaz:" + _resFecha);

      if (_resFecha[0] != "OK") {
        alert("Error en Fecha");
        return;
      } else {
        _fecha = _resFecha[1];
        _fechaProgramada = _resFecha[2];
      }

      if (
        this.usuarioEncontrado == undefined ||
        this.usuarioEncontrado.idUsuario == null
      ) {
        alert("Supervisor no válido");
        return;
      } else _idUsuario = this.usuarioEncontrado.idUsuario;

      if (
        this.cecoSeleccionado == undefined ||
        this.cecoSeleccionado.idCeco == null
      ) {
        alert("ceco no válido");
        return;
      } else _idCeco = this.cecoSeleccionado.idCeco;

      if (
        this.gerenteEncontrado == undefined ||
        this.gerenteEncontrado.idUsuario == null
      ) {
        alert("Coordinador no válido");
        return;
      } else _coordi = this.gerenteEncontrado.idUsuario;

      if (_tipoVisita == "") {
        alert("Seleccione Tipo Visita");
        return;
      }

      if (this.addNegocio == "") {
        alert("Seleccoine Negocio");
        return;
      }

      if (_tipoTarea != "") _tipoTarea = this.verifTipoTarea(_tipoTarea);

      if (_tipoTarea.includes("ERR[")) {
        alert("Error en Tareas a Realizar");
        return;
      }

      //    DATOS   OK
      _idCeco = _idCeco.toString();
      _idCeco = _idCeco.substr(_idCeco.length - 4);

      let supervX = {
        Iden: this.getMaxIden() + 1,
        descripcion: "Supervision Mtto",
        fecha: _fecha,
        fechaProgramada: _fechaProgramada,
        idAgrupa: 1,
        idCeco: _idCeco, // this.cecoSeleccionado.idCeco,
        idProyecto: 1,
        idUsuario: this.usuarioEncontrado.idUsuario,
        usuarioAsigna: this.gerenteEncontrado.idUsuario,
        ordenActivos: "1,2,3",
        comentarioTicketRelacionados: "no hay tks",
        comentarioReprogramacion: "Se reprogramo no",
        negocio: "EKT",
        tipoVisita: "GENERAL",
        verif: "-",
      };

      this.supervs.push(supervX);
      this.dialogAsignacion = false;
      this.limpiaFormulario();
    },
    removeSupervision() {
      let _id = this.itemSeleccionado.Iden;

      this.supervs = this.supervs.filter(function(obj) {
        return obj.Iden !== _id;
      });
    },
    setItemDeleting(objeto) {
      //console.log('Setting Deleting Superv: ' + objeto.item)
      this.itemSeleccionado = objeto.item;
    },
    handleFileDrop(e) {
      this.files = [];
      let droppedFiles = e.dataTransfer.files;
      if (!droppedFiles) return;
      [...droppedFiles].forEach((f) => {
        this.files.push(f);
      });
    },
    getMaxIden() {
      //console.log(this.supervs.length)
      if (this.supervs == undefined || this.supervs.length == 0) return 0;
      return Math.max.apply(
        Math,
        this.supervs.map(function(o) {
          return o.Iden;
        })
      );
    },
    readFile(e) {
      let file;
      if (e.type === "drop") {
        file = e.dataTransfer.files[0];
      } else {
        file = e.target.files[0];
      }
      if (!file) return;
      const size = file.size;
      if (size > 1024 * 1024) {
        this.dialogSize = true;
        return;
      }
      this.file.form_data = file;
      this.file.name_file = file.name;
      this.file.content_type = file.type;

      var reader = new FileReader();
      let listaXls = [];

      reader.onload = (e) => {
        //console.log('Loading')
        var data = new Uint8Array(e.target.result);
        var workbook = XLSX.read(data, {
          type: "array",
        });
        let sheetName = workbook.SheetNames[0];
        let worksheet = workbook.Sheets[sheetName];
        this.infoJson = XLSX.utils.sheet_to_json(worksheet);
        this.validaXls();
      };
      reader.readAsArrayBuffer(file);
    },
    srvCargaSupervisiones() {
      console.log("Xupervisiones SRV");
      console.log(this.supervs);

      axios
        //.post("secure/post/ejecuta/asignacionesSupMtto", this.asignaciones)           // Correo Javi
        //.post("/asignacion-sup/secure/post/ejecuta/asignaciones", this.asignaciones)  //  ORIGINAL
        .post(
          "asignacion-mtto/secure/post/ejecuta/asignacionesSupMtto",
          this.supervs
        )
        .then((response) => {
          //console.log('Mi Response:' + response.status);
          //console.log(response)
          //console.log(response.data)
          if (response) {
            if (response.status == 200 && response.data.data == 1) {
              this.dialogCarga = true;
              this.dialogConfimacionAlta = false;
              this.dialogAsignacion = false;
              this.supervs = [];
              this.valorTab = false;
              //this.altaAsignaGeo();
              this.clrXlsFile();
            } else {
              console.log("Fallo en Carga Supervisiones");
              this.dialogFallo = true;
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    actualizaUsuariosGerentes() {
      if (this.textoGerente != null && this.textoGerente.length > 3) {
        this.getUsuariosGerentes();
      } else {
        this.metadata.gerentes = [];
      }
    },
    validaXls() {
      this.clrData();

      for (var i = 0; i < this.infoJson.length; i++) {
        let _verif = "";
        let _fecha = "";
        let _fechaProgramada = "";
        let _idCeco = this.validaInt(this.infoJson[i].Economico);
        let _tipoVisita = this.validaItemEnArray(
          this.hc_tiposVisita,
          this.infoJson[i].TipoVisita
        );
        let _idUsuario = this.validaInt(this.infoJson[i].Supervisor);
        let _usuarioAsigna = this.validaInt(this.infoJson[i].Coordinador);
        let _tipoTarea = this.verifTipoTarea(
          this.infoJson[i].TipoTarea.toString()
        );
        let _negocio = this.validaItemEnArray(
          this.hc_negocios,
          this.infoJson[i].Negocio
        );
        let _comentarioTicketRelacionados =
          this.infoJson[i].TicketsRelacionados == undefined
            ? ""
            : this.infoJson[i].TicketsRelacionados;
        let _resFecha = this.ValidaFecha(this.infoJson[i].Fecha, "xls");

        if (_resFecha[0] == "OK") {
          _fecha = _resFecha[1];
          _fechaProgramada = _resFecha[2];
        } else _fecha = _resFecha[0];

        if (
          _idCeco.toString().includes("ERR[") ||
          _tipoVisita.includes("ERR[") ||
          _idUsuario.toString().includes("ERR[") ||
          _usuarioAsigna.toString().includes("ERR[") ||
          _tipoTarea.includes("ERR[") ||
          _negocio.includes("ERR[") ||
          _comentarioTicketRelacionados.includes("ERR[") ||
          _fecha.includes("ERR[")
        )
          _verif = "ERROR";
        else _verif = "-";

        let supX = {
          Iden: i + 1,
          idCeco: _idCeco.toString(),
          usuarioAsigna: _usuarioAsigna,
          idUsuario: _idUsuario,
          fechaProgramada: _fechaProgramada,
          fecha: _fecha,
          negocio: _negocio,
          tipoVisita: _tipoVisita,
          ordenActivos: _tipoTarea,
          comentarioTicketRelacionados: _comentarioTicketRelacionados,
          verif: _verif,
          //           Valores fijos
          comentarioReprogramacion: "Se reprogramo no",
          descripcion: "Supervision Mtto",
          idProyecto: 1,
          idAgrupa: 1,
        };
        this.supervs.push(supX);
      }
    },
    ValidaFecha(fecha, tipoVerif) {
      let res = [];
      let arrFecha = [];
      let dia = 0;
      let mes = 0;
      let yr = 0;

      arrFecha = tipoVerif == "xls" ? fecha.split("/") : fecha.split("-");

      if (arrFecha.length != 3) {
        res.push("Err[" + fecha + "]long fecha:" + arrFecha.length);
        return res;
      }

      if ("xls" == tipoVerif) {
        dia = Number.parseInt(arrFecha[0]);
        mes = Number.parseInt(arrFecha[1]);
        yr = Number.parseInt(arrFecha[2]);
      } else if ("man" == tipoVerif) {
        //console.log('tipo verif fecha - man:' + fecha)
        dia = Number.parseInt(arrFecha[2]);
        mes = Number.parseInt(arrFecha[1]);
        yr = Number.parseInt(arrFecha[0]);
      }

      if (isNaN(dia) || isNaN(mes) || isNaN(yr)) {
        res.push("Err[" + fecha + "] Error en número");
        return res;
      }

      if (yr.toString().length != 4) {
        res.push("Err[" + fecha + "] Se requieren 4 dígitos para año");
        return res;
      }

      if (
        dia > 31 ||
        dia < 1 ||
        mes > 12 ||
        mes < 1 ||
        yr.toString().length != 4
      ) {
        res.push("Err[" + fecha + "] Error en valor");
        return res;
      }

      dia = dia < 10 ? "0".concat(dia) : "".concat(dia);
      mes = mes < 10 ? "0".concat(mes) : "".concat(mes);

      let dt1 = dia + "/" + mes + "/" + yr;
      let dt2 = yr
        .toString()
        .concat(mes)
        .concat(dia);

      return ["OK", dt1, dt2];
    },
    validaItemEnArray(arreglo, dato) {
      //   datos = ARRAY con valores posibles
      //console.log('valida cell' + dato)
      if (dato == undefined) {
        return "ERR:Indefinido";
      } else if (arreglo.includes(dato.toUpperCase())) return dato;
      else return "ERR[" + dato + "]";
    },
    validaInt(num) {
      //   datos = ARRAY con valores posibles
      //console.log('valida int:' + num)
      if (Number.parseInt(num)) return num;
      else return "ERR[" + num + ": debería ser un número]";
    },
    verifTipoTarea(strNums) {
      let arrNums = strNums.split(",");
      //= strNums.replace(/\s/g,'')
      for (var j = 0; j < arrNums.length; j++) {
        let numEntero = arrNums[j];
        numEntero = numEntero.trim();
        if (!/^\d+$/.test(numEntero)) {
          return "ERR[" + numEntero + "]" + "  " + strNums;
        }
      }
      return strNums;
    },
    limpiaFormulario() {
      this.addDate = "";

      this.tipoVisita = "";
      this.addTipoVisita = "";
      this.$refs.addTipoVisita.resetValidation();

      this.negocio = "";
      this.addNegocio = "";
      this.$refs.addNegocio.resetValidation();

      this.addTipoTarea = "";
      this.$refs.addTipoTarea.resetValidation();

      this.addComentTickRelacinados = "";
      this.$refs.addComentTickRelacinados.resetValidation();

      (this.ordenActivos = ""), (this.comentarioTicketRelacionados = "");
      this.usuarioEncontrado = "";
      this.cecoSeleccionado = "";
      this.listaTipoNego = "";
      this.metadata.cecos = [];
      this.metadata.negocios = [];
      this.metadata.usuarios = [];
      this.$refs.autoUsuario.resetValidation();
      this.$refs.autoCeco.resetValidation();
      this.habilitaSuc = true;
      this.muestraGeo = false;
      this.zona = "";
      this.territorio = "";
      this.metadata.gerentes = [];
      this.$refs.autoGerente.resetValidation();
    },
    clrXlsFile() {
      this.file = {
        form_data: null,
        name_file: null,
        content_b64: null,
        content_type: null,
      };
    },
    clrData() {
      this.itemSeleccionado = "";
      this.supervs = [];
    },
    setNegociosHardcode() {
      this.habilitaSuc = false;

      this.metadata.cecos = [];
      //this.habilitaSuc=false;
      let punto_venta = {
        descripcion: "PUNTO DE VENTA",
        idNegocio: 1,
        status: 1,
        acronimo: "PV",
        fecha: "2020-11-10 16:23:24",
      };
      this.metadata.negocios.push(punto_venta);
    },
    actualizaUsuarios() {
      if (
        this.textoUsuarioIngresado != null &&
        this.textoUsuarioIngresado.length > 3
      ) {
        this.getUsuarios();
      } else {
        this.metadata.usuarios = [];
      }
    },
    //////////////////////////////////////////////     METHODS  SERVICIOS
    getUsuarios() {
      axios
        .post("/negoVers/secure/post/usuarios", {
          id_usuario: this.idUsuario,
          nombreUsuario: this.nombreUsuario,
          //idPuesto: this.idPuesto,
          idPuesto: 1, //    1 para Supervisores
        })
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              if (response.data.data != undefined) {
                this.metadata.usuarios = response.data.data;
                //console.log(JSON.stringify(this.metadata.usuarios))
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    actualizaCecos() {
      // if (this.textoIngresado != null  && this.textoIngresado.length > 3 && this.negocioSelecionado.idNegocio == 1 ) {
      if (this.textoIngresado != null && this.textoIngresado.length > 3) {
        this.prefijo = 92;
        this.ceco = null;
        this.nombre = this.textoIngresado;
        this.muestraGeo = true;

        console.log("Actualizando CECOS...");
        this.getCecos();
      }
    },
    getCecos() {
      //console.log('ceco / nombreCeco: ' + this.ceco + '/' + this.nombreCeco);
      axios
        .post("negoVers/secure/post/cecos", {
          //prefijo: this.prefijo,
          prefijo: 92,
          idCeco: this.ceco,
          nombreCeco: this.nombre,
        })
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              //console.log('SRV CECOS:' + response.data.data)
              this.metadata.cecos = [];
              for (var i = 0; i < response.data.data.length; i++) {
                this.metadata.cecos.push({
                  nombreCeco: response.data.data[i].nombreCeco,
                  ceco:
                    response.data.data[i].nombreCeco +
                    " - " +
                    response.data.data[i].idCeco,
                  idCeco: response.data.data[i].idCeco,
                });
              }
              console.log("Tot CECOS: " + this.metadata.cecos.length);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    getUsuariosGerentes() {
      axios
        .post("/negoVers/secure/post/usuarios", {
          id_usuario: this.idUsuario,
          nombreUsuario: this.nombreUsuario,
          idPuesto: 2, //    2 para coordinadores
        })
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              if (response.data.data != undefined) {
                this.metadata.gerentes = response.data.data;
                //console.log("entro")
                // console.log(JSON.stringify(this.metadata.gerentes))
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },

    created() {},
  },
};
</script>

<style>
.punteado {
  border-style: dotted;
  border-width: 2px;
  border-color: 660033;
  background-color: cc3366;
  font-size: 20pt;
  padding: 10px;
}

.rayado {
  border-style: dashed;
  border-width: 2px;
  border-color: 660033;
  padding: 10px;
  font-size: 20pt;
}

.altura {
  height: 60px;
}

.anchura {
  width: 200px;
}

.file-wrapper {
  text-align: center;
  width: 100%;
  height: 3em;
  vertical-align: middle;
  position: relative;
  overflow: hidden;
}

.file-wrapper input {
  position: absolute;
  top: 0;
  right: 0;
  cursor: pointer;
  opacity: 0;
  filter: alpha(opacity=0);
  width: 100%;
  height: 100%;
}

.padding {
  padding: 20px;
}
</style>
